; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 800
WINDOWHEIGHT = 600
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 or \
	(sizeof WNDCLASSEX)
	push	rax                     ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	rc:RECT

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
	cmp	edx,WM_PAINT	
	je      wmPAINT
	cmp	edx,WM_TIMER
	je      wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
        invoke	glDeleteLists,lst_Sphere,1
	invoke	gluDeleteQuadric,Quadric_Sphere
       	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmCREATE:invoke	GetDC    ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax;eax=hDC
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;GLInit----------------------------------
	movq	xmm0,constd1
	invoke	glClearDepth
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
	movd	xmm3,const1
	movd	xmm2,ebx
	movd	xmm1,ebx
	movd	xmm0,ebx
	invoke	glClearColor
	invoke	glEnable,GL_NORMALIZE
	invoke	glEnable,GL_CULL_FACE
; Create a sphere
	invoke	glGenLists, 1
	mov	lst_Sphere,rax

	invoke	glNewList, eax, GL_COMPILE
	invoke	gluNewQuadric
	mov	Quadric_Sphere,rax
; Note: These 2 are the default values for quadric objects
	invoke	gluQuadricDrawStyle,eax,GLU_FILL
	invoke	gluQuadricNormals,Quadric_Sphere,GLU_SMOOTH
	movq	xmm1,constd1_8
	invoke	gluSphere,Quadric_Sphere,,36,36
	invoke	glEndList

	invoke	glEnable, GL_LIGHTING
;---------------------------------------------
	invoke	GLReshape, WINDOWWIDTH, WINDOWHEIGHT
        jmp	wmBYE
wmSIZE:;     
	mov	edx,r9d
	movzx	ecx,dx
	shr	edx,16
	invoke	GLReshape
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
;;  
        invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT or GL_STENCIL_BUFFER_BIT
; Draw scene here
	mov	r8d,offset Light_Diffuse
	invoke	glLightfv,GL_LIGHT0,GL_DIFFUSE
	mov	r8d,offset Light_Ambient
	invoke	glLightfv,GL_LIGHT0,GL_AMBIENT
	mov	r8d,offset Light_Position
	invoke	glLightfv,GL_LIGHT0,GL_POSITION
	movd	xmm2,const0_02
	invoke	glLightf,GL_LIGHT0,GL_QUADRATIC_ATTENUATION
	invoke	glEnable,GL_LIGHT0

	invoke	glEnable,GL_DEPTH_TEST
; Draw scene here
	invoke	glPushMatrix
	movd	xmm2,const_3
	movd	xmm1,ebx
	movd	xmm0,ebx
	invoke	glTranslatef
	movd	xmm3,ebx
	movd	xmm2,const1
	movd	xmm1,ebx
	movd	xmm0,RotX
	invoke	glRotatef
	movd	xmm3,ebx
	movd	xmm2,ebx
	movd	xmm1,const1
	movd	xmm0,RotY
	invoke	glRotatef
	movd	xmm3,const1
	movd	xmm2,ebx
	movd	xmm1,ebx
	movd	xmm0,RotZ
	invoke	glRotatef
; GL_SMOOTH is the default model
	invoke	glShadeModel, GL_SMOOTH
	invoke	glViewport,-200,90,WINDOWWIDTH,WINDOWHEIGHT
	invoke	glCallList,lst_Sphere

	invoke	glShadeModel, GL_FLAT
	invoke	glViewport,200,-90,WINDOWWIDTH,WINDOWHEIGHT
	invoke	glCallList,lst_Sphere

	invoke	glPopMatrix

	invoke	glViewport,0,0,WINDOWWIDTH,WINDOWHEIGHT
;   
        invoke	SwapBuffers,hDC
	lea	edx,ps
	invoke	EndPaint,hWin
	jmp	wmBYE
wmTIMER:fninit
	fld	RotX
	fadd	delta
	fstp	RotX
	fld	RotY
	fadd	delta
	fstp	RotY
	fld	RotZ
	fadd	delta
	fstp	RotZ
;------------------------------
	lea	edx,rc
	invoke	GetClientRect,hWin
	lea	edx,rc
	invoke	InvalidateRect,hWin,,0
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp
GLReshape proc w:dword,h:dword
local	resulta:QWORD
local	resultb:QWORD
	
	mov	w,ecx
	mov	h,edx
	mov	r8d,ecx
	mov	r9d,edx
	invoke  glViewport,0,0
	invoke  glMatrixMode,GL_PROJECTION
	invoke  glLoadIdentity

	mov     eax,h
	cmp	w,eax ;if (w <= h)
	ja	@f
	fld	constd_2_5
	fimul	h
	fidiv   w
	fstp    resulta
	fld	constd2_5
	fimul   h
	fidiv   w
	fstp    resultb
	movq	xmm3,resultb	
	movq	xmm2,resulta	
	movq	xmm1,constd2_5	
	movq	xmm0,constd_2_5
	jmp	@0
@@:	fld	constd_2_5
	fimul   w
	fidiv   h
	fstp	resulta
	fld	constd2_5
	fimul   w
	fidiv   h
	fstp    resultb
	movq	xmm3,constd2_5	
	movq	xmm2,constd_2_5
	movq	xmm1,resultb	
	movq	xmm0,resulta	
@0:	invoke  glOrtho,,,,,constd_10,constd10
	invoke	glMatrixMode,GL_MODELVIEW
        invoke  glLoadIdentity
	leave
	retn
GLReshape endp
;-----------------------------------------------------------
hDC	dq	?
hrc	dq	?;  
PixFrm	label	PIXELFORMATDESCRIPTOR 
;   
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1;  
;  ,     
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW 
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	16;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	0;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  

szClassName	db "Uncle Remus tales:#40 OpenGL",0
FileName	db "br_Rabbit3.cur",0
;float
const0_02	dd 0.02
const1		dd 1.0
const_3		dd -3.0
;double----------------------------
constd1		dq 1.0
constd1_8	dq 1.8
constd2_5	dq 2.5
constd_2_5	dq -2.5
constd10	dq 10.0
constd_10	dq -10.0
;Variables
RotX		dd 0.0
RotY		dd 0.0
RotZ		dd 0.0
delta		dd 2.0
lst_Sphere	dq 0
Quadric_Sphere	dq 0

Light_Position	dd -1.0, 1.0, 0.5, 1.0
Light_Diffuse	dd 0.6, 0.8, 0.9, 1.0
Light_Ambient	dd 0.2, 0.5, 0.6, 1.0
end